#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// 
    /// </summary>
    [Description("")]
    public class VolumeSpike : Indicator
    {
        #region Variables
        // Wizard generated variables
            private int period = 5; // Default setting for Period
        // User defined variables (add any user defined variables below)
        #endregion

		
		/*
		http://www.traderslaboratory.com/forums/f56/high-volume-spike-reversal-indicator-development-4515.html
		For a "buy signal", I'm looking for price on the bar after the High Volume Spike to close at or above the close of the High Volume Spike bar. As well, I am looking for a close on the bar after the High Volume Spike that is higher or equal to the open, and for the bar to close off of the lows. I basically ensure closing off the lows by this function (Close-Open)<(High-Low).
		*/
        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            //Add(new Plot(Color.FromKnownColor(KnownColor.Orange), PlotStyle.Bar, "Spike"));
			//Add(new Line(Color.DarkGray, 0, "Zero line"));

            CalculateOnBarClose	= true;
            Overlay				= true;
            PriceTypeSupported	= false;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
            // Use this method for calculating your indicator values. Assign a value to each
            // plot below by replacing 'Close[0]' with your own formula.
			
//HIGH VOLUME SPIKE LONG SIGNAL
			if (CurrentBar > period)
			{
				if ( (Low[0]<=Low[1]) && (Low[0]<=Low[2]) &&
					(Close[0]>=Close[1]) && (Close[0]>=Open[0]) &&
					(Close[0]-Open[0])<(High[0]-Low[0]) &&
					//(Volume[1]>Volume[2]) && (Volume[1]>Volume[3]) && (Volume[1]>Volume[4]) && (Volume[1]>Volume[5]) && (Volume[1]>Volume[6]) )
					(Volume[1]>MAX(Volume,period)[2]) )
				{
					BackColor = Color.Green;
					//Spike.Set(1);
	
				}
				if ( (Low[0]>=Low[1]) && (Low[0]<=Low[2]) &&
					(Close[0]>=Close[1]) && (Close[0]>=Open[0]) &&
					((Close[0]-Open[0])<(High[0]-Low[0])) &&
					//(Volume[1]>Volume[2]) && (Volume[1]>Volume[3]) && (Volume[1]>Volume[4]) && (Volume[1]>Volume[5]) && (Volume[1]>Volume[6]) )
					(Volume[1]>MAX(Volume,period)[2]) )
				{
					BackColor = Color.Lime;
					//Spike.Set(1);
	
				}
				
				
//HIGH VOLUME SPIKE SHORT SIGNAL
				if( (High[0]>=High[1]) && (High[0]>=High[2]) && 
					(Close[0]<=Close[1]) && (Close[0]<=Open[0]) &&
					((Open[0]-Close[0])<(High[0]-Low[0])) &&
					//(Volume[1]>Volume[2]) && (Volume[1]>Volume[3]) && (Volume[1]>Volume[4]) && (Volume[1]>Volume[5]) && (Volume[1]>Volume[6]) )
					(Volume[1]>MAX(Volume,period)[2]) )
				{
					BackColor = Color.Crimson;
					//Spike.Set(-1);
				}
				
				if( (High[0]<=High[1]) && (High[0]>=High[2]) && 
					(Close[0]<=Close[1]) && (Close[0]<=Open[0]) &&
					((Open[0]-Close[0])<(High[0]-Low[0])) &&
					//(Volume[1]>Volume[2]) && (Volume[1]>Volume[3]) && (Volume[1]>Volume[4]) && (Volume[1]>Volume[5]) && (Volume[1]>Volume[6]) )
					(Volume[1]>MAX(Volume,period)[2]) )
				{
					BackColor = Color.Red;
					//Spike.Set(-1);
				}				

			}	
			
			
        }

        #region Properties
		
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Spike
        {
            get { return Values[0]; }
        }

        [Description("")]
        [Category("Parameters")]
        public int Period
        {
            get { return period; }
            set { period = Math.Max(1, value); }
        }
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private VolumeSpike[] cacheVolumeSpike = null;

        private static VolumeSpike checkVolumeSpike = new VolumeSpike();

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public VolumeSpike VolumeSpike(int period)
        {
            return VolumeSpike(Input, period);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public VolumeSpike VolumeSpike(Data.IDataSeries input, int period)
        {
            checkVolumeSpike.Period = period;
            period = checkVolumeSpike.Period;

            if (cacheVolumeSpike != null)
                for (int idx = 0; idx < cacheVolumeSpike.Length; idx++)
                    if (cacheVolumeSpike[idx].Period == period && cacheVolumeSpike[idx].EqualsInput(input))
                        return cacheVolumeSpike[idx];

            VolumeSpike indicator = new VolumeSpike();
            indicator.BarsRequired = BarsRequired;
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;
            indicator.Period = period;
            indicator.SetUp();

            VolumeSpike[] tmp = new VolumeSpike[cacheVolumeSpike == null ? 1 : cacheVolumeSpike.Length + 1];
            if (cacheVolumeSpike != null)
                cacheVolumeSpike.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cacheVolumeSpike = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.VolumeSpike VolumeSpike(int period)
        {
            return _indicator.VolumeSpike(Input, period);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.VolumeSpike VolumeSpike(Data.IDataSeries input, int period)
        {
            return _indicator.VolumeSpike(input, period);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.VolumeSpike VolumeSpike(int period)
        {
            return _indicator.VolumeSpike(Input, period);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.VolumeSpike VolumeSpike(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.VolumeSpike(input, period);
        }

    }
}
#endregion
